import es, cfglib, gamethread, keyvalues, os, playerlib, popuplib, time, usermsg

info = es.AddonInfo()
info.name        = 'grWar'
info.basename    = 'grWar'
info.basename    = 'grWar'
info.version     = '1.0'
info.author      = 'Adz #Gr'
info.url         = 'http://addons.eventscripts.com/addons/view/grWar'
info.description = 'Script: Complete War Plugin'

configuration = cfglib.AddonCFG(es.getAddonPath('grWar') + '/configuration.cfg')
configuration.text('******************************')
configuration.text('War #GlobalRebellion :: Config')
configuration.text('******************************')
maniSupport = configuration.cvar('gr_maniSupport', '0', 'Use admins from cfg/mani_admin_plugin/clients.txt. Yes = 1, No = 0')
scriptUrl   = configuration.cvar('gr_scriptUrl',   '',  'Full url with (without trialling /) to webserver to upload demos to. (Leave blank for none)')
endKick     = configuration.cvar('gr_endKick',     '1', 'Kick all players 30 seconds after !done is performed at the end of a match.')
configuration.text('Place SteamId for Admins below ONLY in the following format with 1 per line:')
configuration.text('addAdmin "STEAM_X:X:XXXXXXXX"')
configuration.command('addAdmin')
configuration.write()

options = ('Swap', 'Kick', 'Ban')
filters = ('Player', 'Team', 'All')

adminList = []
changePasswordUser = []
commandList = ['match', 'teamcash', 'teamweapons', 'teamhealth', 'change', 'rates', 'done', 'commands'] 
rates = {}
changeCount = {}

def load():
    global announcements, publicChat, adminList, maniSupport, adminPopup, adminPopupConfig, configName, adminPopupOption, adminPopupCommands, adminPopupMaps
    announcements = 1
    publicChat = 1
    if announcements == 1:
        es.msg('#multi', '#greenWAR ~ #lightgreenUnloaded.')
    if maniSupport == '1':
        clients = keyvalues.KeyValues('clients.txt')
        clients.load(filename="cfg/mani_admin_plugin/clients.txt")
        adminList = [x['steam'] for x in clients['players']]
    for functionCommand in commandList:
        if not es.exists('command', 'gr_%s' % functionCommand):
            es.regsaycmd('!%s' % functionCommand, 'grWar/%sCmd' % functionCommand)
            es.regclientcmd('gr_%s' % functionCommand, 'grWar/%sCmd' % functionCommand)
    if not es.exists('command', 'addAdmin'):
        es.regcmd('addAdmin', 'grWar/addAdminCmd')

    es.server.queuecmd('changelevel %s' % es.ServerVar('eventscripts_currentmap'))
    es.addons.registerClientCommandFilter(commandFilter)
    es.addons.registerSayFilter(sayFilter)
    
    adminPopup = popuplib.easymenu('adminPopup', None, adminPopup_menuselect)
    adminPopup.settitle('War #GlobalRebellion')
    adminPopup.setdescription(':: Home')
    adminPopup.addoption(1, 'Execute Config')
    adminPopup.addoption(2, 'Knife On 3')
    adminPopup.addoption(3, 'Live On 3')
    adminPopup.addoption(4, 'Change Password')
    adminPopup.addoption(5, 'Manage Players')
    adminPopup.addoption(6, 'Server Commands')
    adminPopup.addoption(7, 'Change Map')

    adminPopupConfig = popuplib.easymenu('adminPopupConfig', None, adminPopupConfig_menuselect)
    adminPopupConfig.settitle('War #GlobalRebellion')
    adminPopupConfig.setdescription(':: Configs')
    for configName in map(lambda x: x.split('.')[0], filter(lambda x: x.endswith('.cfg'), os.listdir(os.path.join(str(es.ServerVar('eventscripts_gamedir')), 'cfg')))):
        adminPopupConfig.addoption(configName, configName)
        
    adminPopupOption = popuplib.easymenu('adminPopupOption', None, adminPopupOption_menuselect)
    adminPopupOption.settitle('War #GlobalRebellion')
    adminPopupOption.setdescription(':: Actions')
    for option in options:
        adminPopupOption.addoption(option, option)

    adminPopupCommands = popuplib.easymenu('adminPopupCommands', None, adminPopupCommands_menuselect)
    adminPopupCommands.settitle('War #GlobalRebellion')
    adminPopupCommands.setdescription(':: Commands')
    adminPopupCommands.addoption(1, 'Restart Server')
    adminPopupCommands.addoption(2, 'Restart Round')
    adminPopupCommands.addoption(3, 'Toggle Public Chat')
    adminPopupCommands.addoption(4, 'Toggle Source Tv')
    adminPopupCommands.addoption(5, 'Toggle Announcements')

    adminPopupMaps = popuplib.easymenu('adminPopupMaps', None, adminPopupMaps_menuselect)
    adminPopupMaps.settitle('War #GlobalRebellion')
    adminPopupMaps.setdescription(':: Maps')
    for mapName in map(lambda x: x.split('.')[0], filter(lambda x: x.endswith('.bsp'), os.listdir(os.path.join(str(es.ServerVar('eventscripts_gamedir')), 'maps')))):
        adminPopupMaps.addoption(mapName, mapName)
        
def unload():
    if announcements == 1:
        es.msg('#multi', '#greenWAR ~ #lightgreenLoaded.')
    es.addons.unregisterSayFilter(sayFilter)
    es.addons.unregisterClientCommandFilter(commandFilter)
    adminPopup.delete()
    adminPopupConfig.delete()
    adminPopupOption.delete()
    adminPopupCommands.delete()
    adminPopupMaps.delete()    
    for functionCommand in commandList:
        if es.exists('command', 'gr_%s' % functionCommand):
            es.unregsaycmd('!%s' % functionCommand)
            es.unregclientcmd('gr_%s' % functionCommand)
        
def es_map_start(ev):
    configuration.execute()

def player_conect(ev):
    userid = int(ev['userid'])
    es.msg('#multi', '#greenWAR ~ #lightgreen%s #defaulthas connected - %s' %(es.getplayername(userid), es.getplayersteamid(userid)))
    
def player_disconnect(ev):
    userid = int(ev['userid'])
    steamid = es.getplayersteamid(userid)
    del rates[userid]
    del changeCount[userid]
    if steamid in changePasswordUser:
        changePasswordUser.remove(steamid)
        
def player_activate(ev):
    userid = int(ev['userid'])
    steamid = es.getplayersteamid(userid)
    username = es.getplayername(userid)
    es.cexec(userid, "echo ")
    es.cexec(userid, "echo ======================================")
    es.cexec(userid, "echo WarPlugin.GlobalRebellion.co.uk")
    es.cexec(userid, "echo ======================================")
    es.cexec(userid, "echo ")
    es.cexec(userid, "echo ")
    es.cexec(userid, "echo *** Gr_War ***")
    es.cexec(userid, "echo :: Commands")
    for functionCommand in commandList:
        es.cexec(userid, "echo -> gr_%s in console or !%s in chat" %(functionCommand, functionCommand))
    if steamid in adminList:
        es.tell(userid, '#multi', '#greenWAR #lightgreen~ #defaultMatch Admin - Type #lightgreen!match #defaultin chat or #lightgreengr_match #defaultin console.')
    rates[userid] = {}
    changeCount[userid] = 0
    es.queryclientvar(userid, 'rate')
    es.queryclientvar(userid, 'cl_cmdrate')
    es.queryclientvar(userid, 'cl_updaterate')
    es.queryclientvar(userid, 'cl_interp')
    es.tell(userid, '#multi', '#greenWar #lightgreen~ #defaultWelcome %s. Check your #lightgreenconsole #defaultfor a full list of commands.' % username)
    es.menu(10, userid, 'Welcome %s\n \nServer Details:\n->1. Hostname: %s\n->2. Ip: %s\n->3. Port: %s\n->4. Map: %s\n \nRate Details:\nrate 25000\ncl_updaterate 100\ncl_cmdrate 100\ncl_interp 0.02' %(username, es.ServerVar('hostname'), es.ServerVar('ip'), es.ServerVar('hostport'), es.ServerVar('eventscripts_currentmap')))
    
def es_player_variable(ev):
    userid = int(ev['userid'])
    if ev['status'] == 'success':
        rates[userid][ev['variable']] = ev['value']    
        
def matchCmd():
    userid = es.getcmduserid()
    if es.getplayersteamid(userid) in adminList:
        adminPopup.send(userid)
    else:
        es.tell(userid, '#multi', '#green[War] #defaultYou are not #lightgreenAdmin.')

def teamcashCmd():
    userid = es.getcmduserid()
    for players in filter(lambda x: es.getplayerteam(x) == es.getplayerteam(userid), es.getUseridList()):
        player = playerlib.getPlayer(players)
        es.tell(userid, '#multi', '#greenWAR #default~ #lightgreen%s: #defaultCash: #lightgreen$%s.' %(es.getplayername(players), player.get("cash")))

def returnStrWeapon(player, weaponType):
    weapon = player.get(weaponType)
    if weapon == "0": return "None"
    return weapon
    
def teamweaponsCmd():
    userid = es.getcmduserid()
    for players in filter(lambda x: es.getplayerteam(x) == es.getplayerteam(userid), es.getUseridList()):
        player = playerlib.getPlayer(players)
        es.tell(userid, '#multi', '#greenWAR #default~ #lightgreen%s: #defaultPrimary - #lightgreen%s #defaultSecondary - #lightgreen%s #defaultHe - #lightgreen%s #defaultFb - #lightgreen%s #defaultSg - #lightgreen%s.' %(es.getplayername(players), returnStrWeapon(player, "primary"), returnStrWeapon(player, "secondary"), returnStrWeapon(player, "HE"), returnStrWeapon(player, "FB"), returnStrWeapon(player, "SG")))

def teamhealthCmd():
    userid = es.getcmduserid()
    for players in filter(lambda x: es.getplayerteam(x) == es.getplayerteam(userid), es.getUseridList()):
        player = playerlib.getPlayer(players)
        username = es.getplayername(players)
        es.tell(userid, '#multi', '#greenWAR #default~ #lightgreen%s: #defaultHealth: #lightgreen%shp.' %(username, player.get("health")))

def changeCmd():
    userid = es.getcmduserid()
    steamid = es.getplayersteamid(userid)
    if steamid in adminList:
        tScore = es.getindexprop(es.getentityindex('cs_team_manager') + 2, 'CCSTeam.baseclass.m_iScore')
        ctScore = es.getindexprop(es.getentityindex('cs_team_manager') + 3, 'CCSTeam.baseclass.m_iScore')
        es.msg('#multi', '#greenWAR ~ #defaultGood Half. T: #lightgreen%s #defaultCT: #lightgreen%s' %(tScore, ctScore))
        es.centermsg('T: %s CT: %s' %(tScore, ctScore))
        for players in es.getUseridList():
            changeCount[players] = 0
            team = es.getplayerteam(players)
            gamethread.delayed(0, es.changeteam, (players, getOpponentTeam(team)))
            changeCount[players] = 1
        gamethread.delayed(5, liveOnThree)
    else:
        es.tell(userid, '#multi', '#green[War] #defaultYou are not #lightgreenAdmin.')
        
def ratesCmd():
    userid = es.getcmduserid()
    es.tell(userid, '#multi', '#green[War] #defaultQuerying all #lightgreenClients... #defaultCheck #lightgreenConsole #defaultin 2 seconds...')
    es.cexec(userid, "echo ")
    es.cexec(userid, "echo ======================================")
    es.cexec(userid, "echo WarPlugin.GlobalRebellion.co.uk")
    es.cexec(userid, "echo ======================================")
    es.cexec(userid, "echo ")
    es.cexec(userid, "echo ")
    es.cexec(userid, "echo *** Gr_Rates ***")
    es.cexec(userid, "echo :: Clients")
    for players in es.getUseridList():
        es.queryclientvar(players, 'rate')
        es.queryclientvar(players, 'cl_cmdrate')
        es.queryclientvar(players, 'cl_updaterate')
        es.queryclientvar(players, 'cl_interp')
        steamid = es.getplayersteamid(players)
        username = es.getplayername(players)
        gamethread.delayed(2, es.cexec, (userid, "echo %s -> Steamid: %s | Rate: %s | Cl_UpdateRate: %s | Cl_CmdRate: %s | Cl_Interp: %s" %(username, steamid, rates[players]['rate'], rates[players]['cl_updaterate'], rates[players]['cl_cmdrate'], rates[players]['cl_interp'])))
        
def doneCmd():
    userid = es.getcmduserid()
    steamid = es.getplayersteamid(userid)
    if steamid in adminList:
        es.usermsg('create', 'panel', 'VGUIMenu')
        es.usermsg('write', 'string', 'panel', 'info')
        es.usermsg('write', 'byte', 'panel', 1)
        es.usermsg('write', 'byte', 'panel', 3)
        es.usermsg('write', 'string', 'panel', 'type')
        es.usermsg('write', 'string', 'panel', '2')
        es.usermsg('write', 'string', 'panel', 'title')
        es.usermsg('write', 'string', 'panel', 'Demos GameServer -> WebServer')
        es.usermsg('write', 'string', 'panel', 'msg')
        es.usermsg('write', 'string', 'panel', scriptUrl)
        es.usermsg('send', 'panel', userid)
        es.usermsg('delete', 'panel')
        if endKick == 1:
            es.msg('#multi', '#green[War] #defaultPost-Match kick will now begin.')
            es.delayed(1, 'es_msg #multi #green[War] #defaultAll players will be #lightgreenkicked #defaultin #lightgreen30 #defaultseconds.')
            es.delayed(10, 'es_msg #multi #green[War] #defaultAll players will be #lightgreenkicked #defaultin #lightgreen20 #defaultseconds.')
            es.delayed(20, 'es_msg #multi #green[War] #defaultAll players will be #lightgreenkicked #defaultin #lightgreen10 #defaultseconds.')
            es.delayed(25, 'es_msg #multi #green[War] #defaultAll players will be #lightgreenkicked #defaultin #lightgreen5 #defaultseconds.')
            es.delayed(26, 'es_msg #multi #green[War] #defaultAll players will be #lightgreenkicked #defaultin #lightgreen4 #defaultseconds.')
            es.delayed(27, 'es_msg #multi #green[War] #defaultAll players will be #lightgreenkicked #defaultin #lightgreen3 #defaultseconds.')
            es.delayed(28, 'es_msg #multi #green[War] #defaultAll players will be #lightgreenkicked #defaultin #lightgreen2 #defaultseconds.')
            es.delayed(29, 'es_msg #multi #green[War] #defaultAll players will be #lightgreenkicked #defaultin #lightgreen1 #defaultsecond.')
            for players in es.getUseridList():
                gamethread.delayed(30, es.server.queuecmd, ('kickid %s' % players))
    elif not steamid in adminList: 
        es.tell(userid, '#multi', '#green[War] #defaultYou are not #lightgreenAdmin.')   
        
def commandsCmd():
    userid = es.getcmduserid()
    steamid = es.getplayersteamid(userid)
    username = es.getplayername(userid)
    es.cexec(userid, "echo ")
    es.cexec(userid, "echo ======================================")
    es.cexec(userid, "echo WarPlugin.GlobalRebellion.co.uk")
    es.cexec(userid, "echo ======================================")
    es.cexec(userid, "echo ")
    es.cexec(userid, "echo ")
    es.cexec(userid, "echo *** Gr_War ***")
    es.cexec(userid, "echo :: Commands")
    for functionCommand in commandList:
        es.cexec(userid, "echo -> gr_%s in console or !%s in chat" %(functionCommand, functionCommand))
        
def addAdminCmd():
    adminList.append(es.getargv(1))
    
def adminPopup_menuselect(userid, choice, popupname):
    if choice == 1:
        adminPopupConfig.send(userid)
    if choice == 2:
        knifeOnThree()
    if choice == 3:
        liveOnThree()
    if choice == 4:
        es.tell(userid, '#multi', '#green[War] #lightgreenType a #defaultPassword #lightgreento set sv_password.')
        es.tell(userid, '#multi', '#green[War] #lightgreenType #defaultNone #lightgreento remove sv_password.')
        es.tell(userid, '#multi', '#green[War] #lightgreenType #defaultSame #lightgreento avoid changing sv_password.')
        changePasswordUser.append(es.getplayersteamid(userid))
    if choice == 5:
        adminPopupOption.send(userid)
    if choice == 6:
        adminPopupCommands.send(userid)
    if choice == 7:
        adminPopupMaps.send(userid)
        
def adminPopupOption_menuselect(userid, choice, popupname):
    global adminPopupFilters
    adminPopupFilters = popuplib.easymenu('adminPopupFilters', None, adminPopupFilters_menuselect)
    adminPopupFilters.settitle('War #GlobalRebellion')
    adminPopupFilters.setdescription(':: Filters')
    for filter in filters:
        adminPopupFilters.addoption('%s_%s' % (choice, filter), '%s %s' % (choice, filter))
    adminPopupFilters.send(userid)

def adminPopupFilters_menuselect(userid, choice, popupname):
    choice = choice.split('_', 1)
    exec('%s(%s, "%s")' % (choice[1], userid, choice[0]))
        
def adminPopupConfig_menuselect(userid, choice, popuname):
    es.server.queuecmd('exec %s' % choice)
    
def Player(userid, choice):
    global adminPopupPlayers
    adminPopupPlayers = popuplib.easymenu('adminPopupPlayers', None, adminPopupPlayers_menuselect)
    adminPopupPlayers.settitle('War #GlobalRebellion')
    adminPopupPlayers.settitle("%s a Player:" % choice)
    for players in es.getUseridList():
        adminPopupPlayers.addoption('%s_%s' % (choice, players), es.getplayername(players))
    adminPopupPlayers.send(userid)

def Team(userid, choice):
    global adminPopupTeam
    adminPopupTeam = popuplib.easymenu('adminPopupTeam', None, adminPopupTeam_menuselect)
    adminPopupTeam.settitle("%s a team:" % choice)
    adminPopupTeam.addoption('%s_2' % choice, '%s Terrorists' % choice)
    adminPopupTeam.addoption('%s_3' % choice, '%s Counter-Terrorists' % choice)
    adminPopupTeam.addoption('%s_1' % choice, '%s Spectators' % choice)
    adminPopupTeam.send(userid)

def All(userid, choice):
    choice = choice.split('_', 1)
    for players in es.getUseridList():
        username = es.getplayername(userid)
        exec '%s(%s, "%s", %s)' % (choice[0], userid, username, players) in globals(), locals()
        
def adminPopupPlayers_menuselect(userid, choice, poupname):
    choice = choice.split('_', 1)
    exec '%s(%s, "%s", %s)' % (choice[0], userid, es.getplayername(userid), choice[1])
    
def adminPopupTeam_menuselect(userid, choice, poupname):
    choice = choice.split('_', 1)
    username = es.getplayername(userid)
    for players in filter(lambda x: es.getplayerteam(x) == int(choice[1]), es.getUseridList()):
        exec '%s(%s, "%s", %s)' % (choice[0], userid, username, players) in globals()

def Swap(userid, username, target):
    team = es.getplayerteam(userid)
    changeCount[target] = 0
    gamethread.delayed(0, es.changeteam, (target, getOpponentTeam(team)))
    changeCount[target] = 1
    es.msg('#multi', '#green[War] #lightgreen%s #defaultSwapped #lightgreen%s' % (username, es.getplayername(target)))
    
def getOpponentTeam(team):
    if team == 2:
        return 3
    elif team == 3:
        return 2
    else:
        return 1

def Kick(userid, username, target):
    es.server.queuecmd('kickid %s' % target)
    es.msg('#multi', '#green[War] #lightgreen%s #defaultKicked #lightgreen%s' % (username, es.getplayername(target)))

def Ban(userid, username, target):
    es.server.queuecmd('ban 5 %s' % target)
    es.msg('#multi', '#green[War] #lightgreen%s #defaultBanned #lightgreen%s' % (username, es.getplayername(target)))
    
def adminPopupCommands_menuselect(userid, choice, poupname):
    global announcements, publicChat
    if choice == 1:
        if announcements == 1:
            es.msg('#multi', '#green[War] #defaultServer is restarting in #lightgreen5 #defaultseconds' % choice)
            es.delayed(1, 'es_msg #multi #green[War] #defaultServer is #lightgreenrestarting #defaultin #lightgreen4 #defaultseconds.' % choice)
            es.delayed(2, 'es_msg #multi #green[War] #defaultServer is #lightgreenrestarting #defaultin #lightgreen3 #defaultseconds.' % choice)
            es.delayed(3, 'es_msg #multi #green[War] #defaultServer is #lightgreenrestarting #defaultin #lightgreen2 #defaultseconds.' % choice)
            es.delayed(4, 'es_msg #multi #green[War] #defaultServer is #lightgreenrestarting #defaultin #lightgreen1 #defaultseconds.' % choice)
        es.delayed(5, 'quit')
    if choice == 2:
        es.server.queuecmd('mp_restartgame 1')
    if choice == 3:
        if publicChat == 1:
            publicChat = 0
            es.msg('#multi', '#green[War] #lightgreenPublic Chat #defaulthas been DISABLED.')
        elif publicChat == 0:
            publicChat = 1
            es.msg('#multi', '#green[War] #lightgreenPublic Chat #defaulthas been ENABLED.')
    if choice == 4:
        if es.ServerVar('tv_enable 1'):
            es.server.queuecmd('tv_enable 0')
            es.msg('#multi', '#green[War] #lightgreenSource Tv #defaulthas been DISABLED.')
        else:
            es.server.queuecmd('tv_enable 1')
            es.msg('#multi', '#green[War] #lightgreenSource Tv #defaulthas been DISABLED.')
    if choice == 5:
        if announcements == 1:
            announcements = 0
            es.msg('#multi', '#green[War] #lightgreenAnnouncements #defaulthave been DISABLED.')
        elif announcements == 0:
            announcements = 1
            es.msg('#multi', '#green[War] #lightgreenAnnouncements #defaulthave been ENABLED.')
    
def adminPopupMaps_menuselect(userid, choice, poupname):
    global announcements
    if announcements == 1:
        es.msg('#multi', '#green[War] #defaultMap is changing to #lightgreen%s #defaultin #lightgreen5 #defaultseconds.' % choice)
        es.delayed(1, 'es_msg #multi #green[War] #defaultMap is changing to #lightgreen%s #defaultin #lightgreen4 #defaultseconds.' % choice)
        es.delayed(2, 'es_msg #multi #green[War] #defaultMap is changing to #lightgreen%s #defaultin #lightgreen3 #defaultseconds.' % choice)
        es.delayed(3, 'es_msg #multi #green[War] #defaultMap is changing to #lightgreen%s #defaultin #lightgreen2 #defaultseconds.' % choice)
        es.delayed(4, 'es_msg #multi #green[War] #defaultMap is changing to #lightgreen%s #defaultin #lightgreen1 #defaultseconds.' % choice)
    gamethread.delayed(5, es.server.queuecmd, ('changelevel %s' % choice))
    
def knifeOnThree():
    es.msg('#multi', '#greenWar #default~ Knife on 3 Restarts')
    gamethread.delayed(1, es.server.queuecmd, ('mp_restartgame 1'))
    es.delayed(2, 'es_msg #multi #greenWAR #default~ Knife on 2 Restarts')
    gamethread.delayed(2, es.server.queuecmd, ('mp_restartgame 1'))
    es.delayed(4, 'es_msg #multi #greenWAR #default~ Knife After Next Restart')
    gamethread.delayed(4, es.server.queuecmd, ('mp_restartgame 1'))
    es.delayed(6, 'es_msg #multi #greenWAR #default~ Knives')
    es.delayed(6, 'es_msg #multi #greenWAR #default~ Knives')
    es.delayed(6, 'es_msg #multi #greenWAR #default~ Knives')
    es.delayed(6, 'es_msg #multi #greenWAR #default~ [G]ood [L]uck & [H]ave [F]un')
    es.delayed(6, 'es_msg #multi #greenWAR #default~ "http://GlobalRebellion.co.uk"')
    for players in es.getUseridList():
        gamethread.delayed(6, es.server.queuecmd, ('es_xgive %s player_weaponstrip' % players))
        gamethread.delayed(6, es.server.queuecmd, ('es_xfire %s player_weaponstrip Strip' % players))
        gamethread.delayed(6, es.server.queuecmd, ('es_xgive %s weapon_knife' % players))
    
def liveOnThree():
    if es.ServerVar('tv_enable') == 1:
        es.server.queuecmd('tv_record %s_%s_%s.dem' %(configName, es.ServerVar('eventscripts_currentmap'), time.strftime('%d-%m-%Y_%M:%H:%S')))
        es.msg('#multi', '#greenWAR #default~ Recording %s_%s_%s.dem' %(configName, es.ServerVar('eventscripts_currentmap'), time.strftime('%d-%m-%Y_%M:%H:%S')))
    es.msg('#multi', '#greenWAR #default~ Live on 3 Restarts')
    gamethread.delayed(1, es.server.queuecmd, ('mp_restartgame 1'))
    es.delayed(2, 'es_msg #multi #greenWAR #default~ Live on 2 Restarts')
    gamethread.delayed(2, es.server.queuecmd, ('mp_restartgame 1'))
    es.delayed(4, 'es_msg #multi #greenWAR #default~ Live After Next Restart')
    gamethread.delayed(4, es.server.queuecmd, ('mp_restartgame 1'))
    es.delayed(6, 'es_msg #multi #greenWAR #default~ Match is Live')
    es.delayed(6, 'es_msg #multi #greenWAR #default~ Match is Live')
    es.delayed(6, 'es_msg #multi #greenWAR #default~ Match is Live')
    es.delayed(6, 'es_msg #multi #greenWAR #default~ [G]ood [L]uck & [H]ave [F]un')
    es.delayed(6, 'es_msg #multi #greenWAR #default~ "http://GlobalRebellion.co.uk"')

def sayFilter(userid, text, teamonly):
    steamid = es.getplayersteamid(userid)
    username = es.getplayername(userid)
    text = text.strip('"')
    if steamid in changePasswordUser:
        if text == "Same" or text == "same":
            changePasswordUser.remove(steamid)
            for admins in adminList:
                if es.getuserid(admins):
                    es.tell(es.getuserid(admins), '#multi', '#green[War] #defaultPassword has #lightgreennot been modified.')
        elif text == "None" or text == "none":
            es.server.queuecmd('sv_password ""')
            changePasswordUser.remove(steamid)
            for admins in adminList:
                if es.getuserid(admins):
                    es.tell(es.getuserid(admins), '#multi', '#green[War] #defaultPassword has been successfully #lightgreenRemoved.')
        else:
            es.server.queuecmd('sv_password %s' % text)
            changePasswordUser.remove(steamid)
            for admins in adminList:
                if es.getuserid(admins):
                    es.tell(es.getuserid(admins), '#multi', '#green[War] #defaultPassword has been successfully #lightgreenChanged to %s.' % text)
        return (0, text, teamonly)
    if publicChat == 1:
        if text.startswith('! '):
            if steamid in adminList:
                if teamonly:
                    for admins in adminList:
                        if es.getuserid(admins):
                            es.tell(es.getuserid(admins), '#multi', '#green[Admin Only] %s: %s' %(username, text[2:]))
                else:
                    es.msg('#multi', '#lightgreen[Admin] %s: %s' %(es.getplayername(userid), text[2:]))
            else:
                es.tell(userid, '[ToAdmin]: %s' % text[2:])
                for admins in adminList:
                    if es.getuserid(admins):
                        es.tell(es.getuserid(admins), '[To Admin] %s: %s' %(username, text[2:]))
            return (0, text, teamonly)
        return (userid, text, teamonly)
    elif publicChat == 0:
        if text.startswith('! '):
            if steamid in adminList:
                if teamonly:
                    for admins in adminList:
                        if es.getuserid(admins):
                            es.tell(es.getuserid(admins), '#multi', '#green[Admin Only] %s: %s' %(username, text[2:]))
                else:
                    es.msg('#multi', '#lightgreen[Admin] %s: %s' %(username, text[2:]))
            else:
                es.tell(userid, '[ToAdmin]: %s' % text[2:])
                for admins in adminList:
                    if es.getuserid(admins):
                        es.tell(es.getuserid(admins), '[To Admin] %s: %s' %(username, text[2:]))
            return (0, text, teamonly)
        elif not text.startswith('! ') and not teamonly and not steamid in changePasswordUser and not text == '!match' and not text == '!teamcash' and not text == '!teamweapons' and not text == '!teamhealth' and not steamid in changePasswordUser:
            return (0, text, teamonly)

def commandFilter(userid, args):
    if args[0].lower() == 'jointeam':
        if changeCount[userid] == 0:
            changeCount[userid] = 1
            return True
        elif changeCount[userid] == 1:
            return False
    else:
        return True